from abc import ABC, abstractmethod


class Model(ABC):
    """
    k
    l
    m
    
    test_year
    validation
    rolling_forecast
    
    X
    y
    
    X_training
    y_training
    X_test
    y_test
    
    X_scaler
    y_scaler
    
    X_training_scaled
    y_training_scaled
    X_test_scaled
    y_test_scaled
    
    y_hat
    y_hat_scaled
    
    model
    
    training_time
    update_time
    
    history
    
    y_hat
    """
    
    @abstractmethod
    def fit(self, test_year, validation='Expanding'):
        pass
    
    @abstractmethod
    def forecast(self):
        pass
    
    @abstractmethod
    def rolling_forecast(self):
        pass
    
    @abstractmethod
    def generate_diagnostics(self):
        pass
    
    @abstractmethod
    def write_to_file(self):
        pass
    
    @abstractmethod
    def _load_X(self):
        pass
    
    @abstractmethod
    def _load_y(self):
        pass
    
    @abstractmethod
    def _split_data(self):
        pass
    
    @abstractmethod
    def _scale_data(self):
        pass