from datetime import datetime
from pandas import DataFrame

from Library.diagnostic_functions import generate_diagnostics
from Library.error_functions import MAE, MAPE
from Library.helper_functions import write_to_file

def naive_model(dw, test_year, hour_last_power_measurement):
    data = dw.get(['power shift_hours=24', 'power shift_hours=48',
                   'power shift_hours=72', 'power shift_hours=96',
                   'power shift_hours=144', 'power shift_hours=168'])
    data = data[datetime(2011, 1, 9, 0):]
    data = data[1:][(data.index.year == test_year)[:-1]]
    
    predictions = []
    for row in data.iterrows():
        if (row[0].hour <= hour_last_power_measurement):
            if (row[0].weekday() == 0):
                predictions.append(row[1]['power shift_hours=72'])
            elif (row[0].weekday() == 5):
                predictions.append(row[1]['power shift_hours=144'])
            else:
                predictions.append(row[1]['power shift_hours=24'])
        else:
            if (row[0].weekday() == 0):
                predictions.append(row[1]['power shift_hours=72'])
            elif (row[0].weekday() == 1):
                predictions.append(row[1]['power shift_hours=96'])
            elif (row[0].weekday() == 5):
                predictions.append(row[1]['power shift_hours=144'])
            elif (row[0].weekday() == 6):
                predictions.append(row[1]['power shift_hours=168'])
            else:
                predictions.append(row[1]['power shift_hours=48'])
            
    predictions = DataFrame(predictions)[0]
    if test_year == 2011:
        power = dw.get('power')['power'][data.index[0]:data.index[-1]]
    else:
        power = dw.get('power')['power'][datetime(test_year,1,1,1):datetime(test_year+1,1,1,0)]
    predictions.index = power.index
    
    generate_diagnostics(power, predictions)
        
    return predictions